package com.liang.dao;

import com.liang.entity.PrjUndertakecompany;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (PrjUndertakecompany)表数据库访问层
 *
 * @author makejava
 * @since 2023-04-09 12:13:16
 */
public interface PrjUndertakecompanyDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjUndertakecompany queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param prjUndertakecompany 查询条件
     * @param pageable            分页对象
     * @return 对象列表
     */
    List<PrjUndertakecompany> queryAllByLimit(PrjUndertakecompany prjUndertakecompany, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjUndertakecompany 查询条件
     * @return 总行数
     */
    long count(PrjUndertakecompany prjUndertakecompany);

    /**
     * 新增数据
     *
     * @param prjUndertakecompany 实例对象
     * @return 影响行数
     */
    int insert(PrjUndertakecompany prjUndertakecompany);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjUndertakecompany> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjUndertakecompany> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjUndertakecompany> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjUndertakecompany> entities);

    /**
     * 修改数据
     *
     * @param prjUndertakecompany 实例对象
     * @return 影响行数
     */
    int update(PrjUndertakecompany prjUndertakecompany);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 通过出资方案删除数据
     *
     * @param czfa
     * @return
     */
    int deleteByCzfa(Integer czfa);

    /**
     * 删除项目承担单位
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 删除项目承担单位
     *
     * @param xmList
     * @return
     */
    int batchDeleteByXm(List<Integer> xmList);

    /**
     * 删除项目承担单位
     *
     * @param czfaList
     * @return
     */
    int batchDeleteByCzfa(List<Integer> czfaList);

    /**
     * 获取承担单位
     *
     * @param czfa
     * @return
     */
    List<PrjUndertakecompany> getUtCompanyList(Integer czfa);

    /**
     * 获取承担单位
     *
     * @return
     */
    List<PrjUndertakecompany> getXmUtCompanyList(Map map);
}

